#!/bin/sh

# Copyright (C) 2004-2014 QVidium Technologies, Inc. All rights reserved.

cat << EOT
Content-type: text/html

<html>
 <head>
  <link href="/style.css" type="text/css" rel="stylesheet">
  <style type="text/css">
    /* row 1 */
    tr td {
       background: #eeeeee; border-color: #eeeeee;
    }
    /* row 2 */
    tr.bis td { 
       background: #cccccc; border-color: #cccccc;
    }
    /* header */
    tr.hdr td { 
       background: #777777; border-color: #777777; color: #eeeeee;
    }
  </style>
  <script type="text/javascript">
    // 1 row on 2 are colored (by adding a class name)
    function setRows(){
      r = document.getElementsByTagName('TR');
      r[0].className = 'hdr';
      for (var i = 1; i < r.length; i++)
        r[i].className = (i/2 != Math.round(i/2))? '':'bis';
    }
    // fire on loading
    onload= function() {
      setRows();
    }
  </script>
  <title>Firewall Log</title>
 </head>
 <body>
EOT

# check for syslogd.  It creates the /var/log/firewall.log file
pidof syslogd > /dev/null 2>&1
if [ $? != 0 ] ; then
    cat << EOT
  The System Log is not running.<p>
  To log dropped packets please to go "System -> Syslog Conf" menu to enable the System Log.
 </body>
</html>
EOT
    exit 0
fi

cat << EOT
  <h2>Dropped Log</h2>
  Current Time: 
EOT

date -R

cat << EOT
  <p>
  <table cellSpacing="0" cellPadding="5" border="0">
   <tr align="left">
    <td>Time</td>
    <td>Interface</td>
    <td>Source IP</td>
    <td>Dest IP</td>
    <td>Protocol</td>
    <td>Source Port</td>
    <td>Dest Port</td>
   </tr>
EOT

while read line
do
    echo "$line" | grep InDrop: > /dev/null
    if [ $? = 0 ] ; then
        DATE=$(echo $line | cut -f1-3 -d' ')
        eval `echo $line | sed 's/^.*InDrop://;s/ /\n/g' | grep '[A-Za-z]*='`
        cat << EOT
   <tr>
    <td>$DATE</td>
    <td>$IN</td>
    <td>$SRC</td>
    <td>$DST</td>
    <td>$PROTO</td>
    <td>$SPT</td>
    <td>$DPT</td>
   </tr>
EOT
    fi
done < /var/log/firewall.log

cat << EOT
  </table>
 </body>
</html>
EOT
