#!/bin/sh

INSTALL_DIR=/disk/netfilter
BACKUP_DIR=/tmp/backup$$
UPDATE_FILE=netfilter.tar.gz
BACKUP_FILELIST="netfilter.conf whitelist"

[ -f $INSTALL_DIR/rc.reset ] && sh $INSTALL_DIR/rc.reset

# Create backup directory
mkdir $BACKUP_DIR

# Backup files
for file in $BACKUP_FILELIST
do
    backup_file=$INSTALL_DIR/$file
    [ -f $backup_file ] && cp $backup_file $BACKUP_DIR
done
sync

# Clean install directory
rm -rf $INSTALL_DIR
sync

# Install new software
tar xf /tmp/$UPDATE_FILE -C /disk
sync

# Restore saved files
for file in $BACKUP_FILELIST
do
    backup_file=$BACKUP_DIR/$file
    [ -f $backup_file ] && cp $backup_file $INSTALL_DIR
done
sync

# Delete backup directory
rm -rf $BACKUP_DIR

# Cleanup files
rm -f $UPDATE_FILE script.sh install.sh
sync

sh $INSTALL_DIR/rc.netfilter

exit 0
